###################################################
### chunk number 1: 
###################################################
#line 124 "/builddir/build/BUILD/systemfit/systemfit/inst/doc/systemfit.Rnw"
options( prompt = "R> ", ctinue = "+  " )


###################################################
### chunk number 2:  eval=FALSE
###################################################
## #line 1442 "/builddir/build/BUILD/systemfit/systemfit/inst/doc/systemfit.Rnw"
## sigmaInv <- solve( residCov )
## xtOmegaInv <- crossprod( xMat, kronecker( sigmaInv, Diagonal( nObs ) ) )
## coef <- solve( xtOmegaInv %*% xMat, xtOmegaInv %*%  yVec )


###################################################
### chunk number 3: systemfit_usage
###################################################
#line 1547 "/builddir/build/BUILD/systemfit/systemfit/inst/doc/systemfit.Rnw"
library( "systemfit" )
data( "Kmenta" )
attach( Kmenta )
eqDemand <- consump ~ price + income
eqSupply <- consump ~ price + farmPrice + trend
eqSystem <- list( demand = eqDemand, supply = eqSupply )
fitols <- systemfit( eqSystem )
print( fitols )


###################################################
### chunk number 4: systemfit_usage
###################################################
#line 1599 "/builddir/build/BUILD/systemfit/systemfit/inst/doc/systemfit.Rnw"
fitsur <- systemfit( eqSystem, method = "SUR" )


###################################################
### chunk number 5: systemfit_usage
###################################################
#line 1621 "/builddir/build/BUILD/systemfit/systemfit/inst/doc/systemfit.Rnw"
fit3sls  <- systemfit( eqSystem, method = "3SLS",
   inst = ~ income + farmPrice + trend )
fit3sls2 <- systemfit( eqSystem, method = "3SLS",
   inst = list( ~ farmPrice + trend, ~ income + farmPrice + trend ) )


###################################################
### chunk number 6: systemfit_usage
###################################################
#line 1639 "/builddir/build/BUILD/systemfit/systemfit/inst/doc/systemfit.Rnw"
fitsur <- systemfit( eqSystem, method = "SUR", data = Kmenta )


###################################################
### chunk number 7: systemfit_usage
###################################################
#line 1669 "/builddir/build/BUILD/systemfit/systemfit/inst/doc/systemfit.Rnw"
restrict <- "demand_price + supply_farmPrice = 0"
fitsurRmat <- systemfit(eqSystem, method = "SUR",
   restrict.matrix = restrict)


###################################################
### chunk number 8: systemfit_usage
###################################################
#line 1680 "/builddir/build/BUILD/systemfit/systemfit/inst/doc/systemfit.Rnw"
Rmat <- matrix(0, nrow = 1, ncol = 7)
Rmat[1, 2] <- 1
Rmat[1, 6] <- 1
qvec <- c(0)
fitsurRmatNum <- systemfit(eqSystem, method = "SUR",
   restrict.matrix = Rmat, restrict.rhs = qvec)


###################################################
### chunk number 9: systemfit_usage
###################################################
#line 1708 "/builddir/build/BUILD/systemfit/systemfit/inst/doc/systemfit.Rnw"
modRegMat <- matrix(0, nrow = 7, ncol = 6)
modRegMat[1:5, 1:5] <- diag(5)
modRegMat[6, 2] <- -1
modRegMat[7, 6] <- 1
fitsurRegMat <- systemfit(eqSystem, method = "SUR",
   restrict.regMat = modRegMat)


###################################################
### chunk number 10: systemfit_usage
###################################################
#line 1726 "/builddir/build/BUILD/systemfit/systemfit/inst/doc/systemfit.Rnw"
all.equal( coef( fitsurRmat ), coef( fitsurRmatNum ) )
all.equal( coef( fitsurRmat ), coef( fitsurRegMat ) )


###################################################
### chunk number 11: systemfit_usage
###################################################
#line 1756 "/builddir/build/BUILD/systemfit/systemfit/inst/doc/systemfit.Rnw"
fitsurit <- systemfit( eqSystem, method = "SUR", maxiter = 500 )


###################################################
### chunk number 12: systemfit_usage
###################################################
#line 1919 "/builddir/build/BUILD/systemfit/systemfit/inst/doc/systemfit.Rnw"
summary( fitsur )


###################################################
### chunk number 13: systemfit_usage
###################################################
#line 1967 "/builddir/build/BUILD/systemfit/systemfit/inst/doc/systemfit.Rnw"
summary( fitsur, residCov = FALSE, equations = FALSE )


###################################################
### chunk number 14: systemfit_usage
###################################################
#line 2011 "/builddir/build/BUILD/systemfit/systemfit/inst/doc/systemfit.Rnw"
data( "GrunfeldGreene" )
library( "plm" )
GGPanel <- plm.data( GrunfeldGreene, c( "firm", "year" ) )
greeneSur <- systemfit( invest ~ value + capital, method = "SUR",
   data = GGPanel )


###################################################
### chunk number 15: systemfit_usage
###################################################
#line 2033 "/builddir/build/BUILD/systemfit/systemfit/inst/doc/systemfit.Rnw"
greeneSurPooled <- systemfit( invest ~ value + capital, method = "SUR",
   data = GGPanel, pooled = TRUE )


###################################################
### chunk number 16: systemfit_usage
###################################################
#line 2052 "/builddir/build/BUILD/systemfit/systemfit/inst/doc/systemfit.Rnw"
linearHypothesis( fitsur, Rmat, qvec, test = "FT" )

linearHypothesis( fitsur, Rmat, qvec, test = "F" )

linearHypothesis( fitsur, Rmat, qvec, test = "Chisq" )

lrtest( fitsurRmat, fitsur )


###################################################
### chunk number 17: systemfit_usage
###################################################
#line 2109 "/builddir/build/BUILD/systemfit/systemfit/inst/doc/systemfit.Rnw"
fit2sls  <- systemfit( eqSystem, method = "2SLS",
   inst = ~ income + farmPrice + trend, data = Kmenta )
fit3sls <- systemfit( eqSystem, method = "3SLS",
   inst = ~ income + farmPrice + trend, data = Kmenta )
hausman.systemfit( fit2sls, fit3sls )


###################################################
### chunk number 18: 
###################################################
#line 2116 "/builddir/build/BUILD/systemfit/systemfit/inst/doc/systemfit.Rnw"
hausmantest <- hausman.systemfit( fit2sls, fit3sls )


###################################################
### chunk number 19: systemfit_replication
###################################################
#line 2172 "/builddir/build/BUILD/systemfit/systemfit/inst/doc/systemfit.Rnw"
library( "systemfit" )


###################################################
### chunk number 20: systemfit_replication
###################################################
#line 2175 "/builddir/build/BUILD/systemfit/systemfit/inst/doc/systemfit.Rnw"
data( "Kmenta" )
eqDemand <- consump ~ price + income
eqSupply <- consump ~ price + farmPrice + trend
inst <- ~ income + farmPrice + trend
system <- list( demand = eqDemand, supply = eqSupply )


###################################################
### chunk number 21: systemfit_replication
###################################################
#line 2183 "/builddir/build/BUILD/systemfit/systemfit/inst/doc/systemfit.Rnw"
fitOls <- systemfit( system, data = Kmenta )
round( coef( summary( fitOls ) ), digits = 4 )


###################################################
### chunk number 22: systemfit_replication
###################################################
#line 2188 "/builddir/build/BUILD/systemfit/systemfit/inst/doc/systemfit.Rnw"
fit2sls <- systemfit( system, method = "2SLS", inst = inst, data = Kmenta )
round( coef( summary( fit2sls ) ), digits = 4 )


###################################################
### chunk number 23: systemfit_replication
###################################################
#line 2193 "/builddir/build/BUILD/systemfit/systemfit/inst/doc/systemfit.Rnw"
fit3sls <- systemfit( system, method = "3SLS", inst = inst, data = Kmenta )
round( coef( summary( fit3sls ) ), digits = 4 )


###################################################
### chunk number 24: systemfit_replication
###################################################
#line 2198 "/builddir/build/BUILD/systemfit/systemfit/inst/doc/systemfit.Rnw"
fitI3sls <- systemfit( system, method = "3SLS", inst = inst, data = Kmenta,
   maxit = 250 )
round( coef( summary( fitI3sls ) ), digits = 4 )


###################################################
### chunk number 25: systemfit_replication
###################################################
#line 2229 "/builddir/build/BUILD/systemfit/systemfit/inst/doc/systemfit.Rnw"
data( "KleinI" )
eqConsump  <- consump ~ corpProf + corpProfLag + wages
eqInvest   <- invest ~ corpProf + corpProfLag + capitalLag
eqPrivWage <- privWage ~ gnp + gnpLag + trend
inst <- ~ govExp + taxes + govWage + trend + capitalLag + corpProfLag + gnpLag
system <- list( Consumption = eqConsump, Investment = eqInvest,
   PrivateWages = eqPrivWage )


###################################################
### chunk number 26: systemfit_replication
###################################################
#line 2239 "/builddir/build/BUILD/systemfit/systemfit/inst/doc/systemfit.Rnw"
kleinOls <- systemfit( system, data = KleinI )
round( coef( summary( kleinOls ) ), digits = 3 )


###################################################
### chunk number 27: systemfit_replication
###################################################
#line 2244 "/builddir/build/BUILD/systemfit/systemfit/inst/doc/systemfit.Rnw"
klein2sls <- systemfit( system, method = "2SLS", inst = inst, data = KleinI,
   methodResidCov = "noDfCor" )
round( coef( summary( klein2sls ) ), digits = 3 )


###################################################
### chunk number 28: systemfit_replication
###################################################
#line 2250 "/builddir/build/BUILD/systemfit/systemfit/inst/doc/systemfit.Rnw"
klein3sls <- systemfit( system, method = "3SLS", inst = inst, data = KleinI,
   methodResidCov = "noDfCor" )
round( coef( summary( klein3sls ) ), digits = 3 )


###################################################
### chunk number 29: systemfit_replication
###################################################
#line 2256 "/builddir/build/BUILD/systemfit/systemfit/inst/doc/systemfit.Rnw"
kleinI3sls <- systemfit( system, method = "3SLS", inst = inst, data = KleinI,
   methodResidCov = "noDfCor", maxit = 500 )
round( coef( summary( kleinI3sls ) ), digits = 3 )


###################################################
### chunk number 30: systemfit_replication
###################################################
#line 2301 "/builddir/build/BUILD/systemfit/systemfit/inst/doc/systemfit.Rnw"
data( "GrunfeldGreene" )
library( "plm" )
GGPanel <- plm.data( GrunfeldGreene, c( "firm", "year" ) )
formulaGrunfeld <- invest ~ value + capital


###################################################
### chunk number 31: systemfit_replication
###################################################
#line 2308 "/builddir/build/BUILD/systemfit/systemfit/inst/doc/systemfit.Rnw"
greeneOls <- systemfit( formulaGrunfeld,
   data = GGPanel )
round( coef( summary( greeneOls ) ), digits = 4 )
round( sapply( greeneOls$eq, function(x){return(summary(x)$ssr/20)} ), digits = 3 )


###################################################
### chunk number 32: systemfit_replication
###################################################
#line 2315 "/builddir/build/BUILD/systemfit/systemfit/inst/doc/systemfit.Rnw"
greeneOlsPooled <- systemfit( formulaGrunfeld,
   data = GGPanel, pooled = TRUE )
round( coef( summary( greeneOlsPooled$eq[[1]] ) ), digits = 4 ) #$
sum( sapply( greeneOlsPooled$eq, function(x){return(summary(x)$ssr)}) )/100


###################################################
### chunk number 33: systemfit_replication
###################################################
#line 2322 "/builddir/build/BUILD/systemfit/systemfit/inst/doc/systemfit.Rnw"
greeneSur <- systemfit( formulaGrunfeld, method = "SUR",
   data = GGPanel, methodResidCov = "noDfCor" )
round( coef( summary( greeneSur ) ), digits = 4 )
round( greeneSur$residCov, digits = 3 ) #$
round( summary( greeneSur )$residCor, digits = 3 ) #$


###################################################
### chunk number 34: systemfit_replication
###################################################
#line 2330 "/builddir/build/BUILD/systemfit/systemfit/inst/doc/systemfit.Rnw"
greeneSurPooled <- systemfit( formulaGrunfeld, method = "SUR",
   data = GGPanel, pooled = TRUE, methodResidCov = "noDfCor",
   residCovWeighted = TRUE )
round( coef( summary( greeneSurPooled$eq[[1]] ) ), digits = 4 ) #$

round( greeneSurPooled$residCov, digits = 3 ) #$
round( cov( residuals( greeneSurPooled ) ), digits = 3 )
round( summary( greeneSurPooled )$residCor, digits = 3 ) #$


###################################################
### chunk number 35: systemfit_replication
###################################################
#line 2376 "/builddir/build/BUILD/systemfit/systemfit/inst/doc/systemfit.Rnw"
GrunfeldTheil <- subset( GrunfeldGreene,
   firm %in% c( "General Electric", "Westinghouse" ) )
GTPanel <- plm.data( GrunfeldTheil, c( "firm", "year" ) )
formulaGrunfeld <- invest ~ value + capital


###################################################
### chunk number 36: systemfit_replication
###################################################
#line 2383 "/builddir/build/BUILD/systemfit/systemfit/inst/doc/systemfit.Rnw"
theilOls <- systemfit( formulaGrunfeld,
   data = GTPanel )
round( coef( summary( theilOls ) ), digits = 3 )


###################################################
### chunk number 37: systemfit_replication
###################################################
#line 2389 "/builddir/build/BUILD/systemfit/systemfit/inst/doc/systemfit.Rnw"
theilSur <- systemfit( formulaGrunfeld, method = "SUR",
   data = GTPanel, methodResidCov = "noDfCor" )
round( coef( summary( theilSur ) ), digits = 3 )


###################################################
### chunk number 38: systemfit_replication
###################################################
#line 2409 "/builddir/build/BUILD/systemfit/systemfit/inst/doc/systemfit.Rnw"
RMatrix <- rbind( c( 0, 1, 0, 0, -1, 0 ), c( 0, 0, 1, 0, 0, -1 ) )
linearHypothesis( theilSur, RMatrix )


###################################################
### chunk number 39: systemfit_replication
###################################################
#line 2415 "/builddir/build/BUILD/systemfit/systemfit/inst/doc/systemfit.Rnw"
theilSurRestr <- systemfit(formulaGrunfeld, method = "SUR",
   data = GTPanel, methodResidCov = "noDfCor", restrict.matrix = RMatrix,
   residCovRestricted = FALSE)
round(coef(summary(theilSurRestr)), digits = 3)


###################################################
### chunk number 40: systemfit_timings
###################################################
#line 2595 "/builddir/build/BUILD/systemfit/systemfit/inst/doc/systemfit.Rnw"
library( "systemfit" )
set.seed( 1 )
systemfitModel <- createSystemfitModel( nEq = 8, nReg = 10, nObs = 750 )
system.time(
   fitMatrix <- systemfit( systemfitModel$formula, method = "SUR",
      data = systemfitModel$data )
)
system.time(
   fitTrad <- systemfit( systemfitModel$formula, method = "SUR",
      data = systemfitModel$data, useMatrix = FALSE )
)
all.equal( fitMatrix, fitTrad )


###################################################
### chunk number 41: systemfit_timings
###################################################
#line 2621 "/builddir/build/BUILD/systemfit/systemfit/inst/doc/systemfit.Rnw"
smallModel <- createSystemfitModel( nEq = 3, nReg = 4, nObs = 50 )
system.time(
   fitSmallMatrix <- systemfit( smallModel$formula, method = "SUR",
      data = smallModel$data, maxit = 500 )
)
system.time(
   fitSmallTrad <- systemfit( smallModel$formula, method = "SUR",
      data = smallModel$data, maxit = 500, useMatrix = FALSE )
)
all.equal( fitSmallMatrix, fitSmallTrad )


###################################################
### chunk number 42: 
###################################################
#line 2643 "/builddir/build/BUILD/systemfit/systemfit/inst/doc/systemfit.Rnw"
options( width = 75 )


###################################################
### chunk number 43: systemfit_sem
###################################################
#line 2653 "/builddir/build/BUILD/systemfit/systemfit/inst/doc/systemfit.Rnw"
library( "sem" )
library( "systemfit" )
data( "KleinI" )


###################################################
### chunk number 44: systemfit_sem
###################################################
#line 2661 "/builddir/build/BUILD/systemfit/systemfit/inst/doc/systemfit.Rnw"
limlRam <- matrix(c(
   "consump  <-  corpProf",    "consump_corpProf",    NA,
   "consump  <-  corpProfLag", "consump_corpProfLag", NA,
   "consump  <-  wages",       "consump_wages",       NA,
   "invest   <-  corpProf",    "invest_corpProf",     NA,
   "invest   <-  corpProfLag", "invest_corpProfLag",  NA,
   "invest   <-  capitalLag",  "invest_capitalLag",   NA,
   "privWage <-  gnp",         "privWage_gnp",        NA,
   "privWage <-  gnpLag",      "privWage_gnpLag",     NA,
   "privWage <-  trend",       "privWage_trend",      NA,
   "consump  <-> consump",     "s11", NA,
   "privWage <-> privWage",    "s22", NA,
   "invest   <-> invest",      "s33", NA),
   ncol = 3, byrow = TRUE)
class(limlRam) <- "mod"
exogVar <- c("corpProf", "corpProfLag", "wages", "capitalLag", "trend",
   "gnp", "gnpLag")
endogVar <- c("consump", "invest", "privWage")
allVar <- c(exogVar, endogVar)

limlResult <- sem(ram = limlRam, S = cov(KleinI[ -1, allVar ]),
   N = (nrow(KleinI) - 1), fixed.x = exogVar)
print(limlResult)


###################################################
### chunk number 45: systemfit_sem
###################################################
#line 2689 "/builddir/build/BUILD/systemfit/systemfit/inst/doc/systemfit.Rnw"
eqConsump <- consump ~ corpProf + corpProfLag + wages
eqInvest <- invest ~ corpProf + corpProfLag + capitalLag
eqPrivWage <- privWage ~ gnp + gnpLag + trend
system <- list(consump = eqConsump, invest = eqInvest,
   privWage = eqPrivWage)
olsResult <- systemfit(system, data = KleinI)
print(olsResult)


###################################################
### chunk number 46: systemfit_sem
###################################################
#line 2702 "/builddir/build/BUILD/systemfit/systemfit/inst/doc/systemfit.Rnw"
fimlRam <- rbind(limlRam,
   c("consump  <-> invest",   "s12", NA),
   c("consump  <-> privWage", "s13", NA),
   c("privWage <-> invest",   "s23", NA))
class(fimlRam) <- "mod"

fimlResult <- sem(ram = fimlRam, S = cov(KleinI[ -1, allVar ]),
   N = (nrow(KleinI) - 1), fixed.x = exogVar)
print(fimlResult)


###################################################
### chunk number 47: systemfit_sem
###################################################
#line 2717 "/builddir/build/BUILD/systemfit/systemfit/inst/doc/systemfit.Rnw"
surResult <- systemfit( system, method = "SUR", data = KleinI,
   methodResidCov = "noDfCor", maxit = 500 )
print( surResult )


